]> git.cworth.org Git - empires-server/blob - test
8659c64b7d63207eef9defb6d2f19d957237194b
[empires-server] / test
1 #!/bin/bash
2
3 # Arrange for some cleanup to be executed if the user interrupts the
4 # test sutie (for example, by pressing ControlC at the controlling
5 # terminal).
6 cleanup_and_report() {
7     empathy_deactivate_all >/dev/null 2>&1
8     TEST_REPORT
9     exit $?
10 }
11 trap cleanup_and_report INT
12
13 usage ()
14 {
15     echo "Usage:$0 <URL-to-test>"
16 }
17
18 if [ $# -lt 1 ]; then
19     echo "Error: No test URL given." >&2
20     echo "" >&2
21     usage >&2
22     exit 1
23 fi
24
25 URL=$1
26 CURL="curl --silent --show-error"
27
28 _TEST_SECTION()
29 {
30     echo ""
31     echo $1
32     echo $1 | sed -e "s/./$2/g"
33 }
34
35 TEST_SECTION()
36 {
37     _TEST_SECTION "$1" =
38 }
39
40 TEST_SUBSECTION()
41 {
42     _TEST_SECTION "$1" -
43 }
44
45 TEST()
46 {
47     printf "    $1"
48     printf "%*s" $(( 52 - ${#1} )) | tr ' ' '.'
49     (( tests_total++ )) || true
50 }
51
52 # Result of test depends on the exit status of last command
53 TEST_END()
54 {
55     if [ $? -eq 0 ]; then
56         echo -n "OK"
57     else
58         (( tests_failed++ )) || true
59         echo -n "FAIL"
60     fi
61
62     # If we got an argument, append it after test result
63     if [ -n "$1" ]; then
64         echo " $1"
65     else
66         echo ""
67     fi
68 }
69
70 # Print report of all previous test results
71 TEST_REPORT()
72 {
73     echo ""
74     echo ""
75     echo "Test Report"
76     echo "==========="
77
78     if [ "$tests_failed" == "" ]; then
79         echo "All $tests_total tests passed."
80         echo ""
81         return 0
82     else
83         echo "$tests_failed of $tests_total tests failed."
84         echo ""
85         return 1
86     fi
87 }
88
89 # Does a string contain a regular expression pattern
90 #
91 # Example:
92 #
93 #    contains "All's well that ends well" "s.well"
94 contains()
95 {
96     grep -q "$2" <<< $1
97 }
98
99 # POST to a URL endpoint with optional JSON data
100 #
101 # Usage:
102 #
103 # curl_post <ENDPOINT> [data] [CURL_OPTIONS]
104 curl_post()
105 {
106     $CURL ${3:-} -X POST ${2:+-H 'Content-Type: application/json' -d "$2"} $URL/$1
107 }
108
109 # POST to a URL endpoint with optional JSON data using a cookie
110 #
111 # Usage:
112 #
113 # curl_post_cookie <name> <ENDPOINT> [data] [CURL_OPTIONS]
114 #
115 # Where <name> is a string for which there is a defined variable
116 # named ${name}_cookie which in turn holds a value that is a filename
117 # of a valid cookie
118 curl_post_cookie()
119 {
120     cookie=${1}_cookie
121     curl_post $2 "${3:-}" "-b ${!cookie} ${4:-}"
122 }
123
124 # PUT to a URL endpoint with optional JSON data
125 #
126 # Usage:
127 #
128 # curl_post <ENDPOINT> [data] [CURL_OPTIONS]
129 curl_put()
130 {
131     $CURL ${3:-} -X PUT ${2:+-H 'Content-Type: application/json' -d "$2"} $URL/$1
132 }
133
134 # GET from a URL endpoint
135 #
136 # Usage:
137 #
138 # curl_get <ENDPOINT> [CURL_OPTIONS]
139 curl_get()
140 {
141     $CURL ${2:-} $URL/$1
142 }
143
144 # GET from a URL endpoint using a cookie
145 #
146 # Usage:
147 #
148 # curl_get_cookie <name> <ENDPOINT> [CURL_OPTIONS]
149 #
150 # Where <name> is a string for which there is a defined variable
151 # named ${name}_cookie which in turn holds a value that is a filename
152 # of a valid cookie
153 curl_get_cookie()
154 {
155     cookie=${1}_cookie
156     curl_get $2 "-b ${!cookie} ${3:-}"
157 }
158
159 # Create a new game of the specified engine type
160 #
161 # Usage:
162 #
163 # new_game <ENGINE>
164 new_game()
165 {
166     curl_post new/$1 | jq -r .
167 }
168
169 TEST_SECTION "LMNO (super-site for games)"
170
171 TEST_SUBSECTION "Testing home page"
172 home_page=$($CURL $URL)
173
174 TEST "Contains 'Join Game'"
175 contains "$home_page" "Join Game"
176 TEST_END
177
178 TEST "Contains 'Host a new game'"
179 contains "$home_page" "Host a new game"
180 TEST_END
181
182 TEST_SUBSECTION "Creating some new games"
183
184 TEST "Empires"
185 empires_game_id=$(new_game empires)
186 test "$empires_game_id" != ""
187 TEST_END $empires_game_id
188
189 TEST "Tic Tac Toe"
190 tictactoe_game_id=$(new_game tictactoe)
191 test "$tictactoe_game_id" != ""
192 TEST_END $tictactoe_game_id
193
194 TEST_SUBSECTION "Test redirects"
195
196 TEST "Redirect of /GAMEID at top level"
197 redirect=$(curl_get $empires_game_id)
198 test "$redirect" = "Moved Permanently. Redirecting to /empires/$empires_game_id/"
199 TEST_END
200
201 TEST "Redirect of lowercase /gameid at top level"
202 empires_game_id_lower=$(tr '[:upper:]' '[:lower:]' <<< $empires_game_id)
203 redirect=$(curl_get $empires_game_id_lower)
204 test "$redirect" = "Moved Permanently. Redirecting to /$empires_game_id/"
205 TEST_END
206
207 TEST "Redirect of lowercase /empires/gameid"
208 redirect=$(curl_get empires/$empires_game_id_lower)
209 test "$redirect" = "Moved Permanently. Redirecting to /empires/$empires_game_id/"
210 TEST_END
211
212 TEST_SECTION "Empires game"
213
214 empires_game_path=empires/$empires_game_id
215
216 TEST_SUBSECTION "Empires game /register"
217
218 empires_register()
219 {
220     curl_post $empires_game_path/register "{\"name\": \"$1\", \"character\": \"$2\"}"
221 }
222
223 empires_players_string()
224 {
225     curl_get $empires_game_path/players | jq -r .[].name | tr '\n' ','
226 }
227
228 empires_characters_string()
229 {
230     curl_get $empires_game_path/characters | jq -r .[] | tr '\n' ','
231 }
232
233 TEST "Registering a player returns an ID"
234 carl_id=$(empires_register Carl "Bugs Bunny" | jq -r .)
235 test "$carl_id" = "1"
236 TEST_END
237
238 TEST "Registering several more players"
239 empires_register Richard "Bob Hope" > /dev/null
240 empires_register Kevin "Elvis Presley" > /dev/null
241 empires_register Stacy Phineas > /dev/null
242 empires_register David "Red Power Ranger" > /dev/null
243 empires_register Nancy "Audrey Hepburn" > /dev/null
244 bogus_id=$(empires_register Bogus "Mr. Bogus")
245 TEST_END
246
247 TEST 'Verify complete players list (with "Bogus")'
248 players=$(empires_players_string)
249 test "$players" = "Carl,Richard,Kevin,Stacy,David,Nancy,Bogus,"
250 TEST_END
251
252 TEST 'Verify complete players list (with "Mr. Bogus")'
253 characters=$(empires_characters_string)
254 test "$characters" = "Bugs Bunny,Bob Hope,Elvis Presley,Phineas,Red Power Ranger,Audrey Hepburn,Mr. Bogus,"
255 TEST_END
256
257 TEST_SUBSECTION "Empires game /deregister"
258
259 empires_deregister()
260 {
261     curl_post $empires_game_path/deregister/$1
262 }
263
264 TEST "Removing the bogus player"
265 empires_deregister $bogus_id
266 TEST_END
267
268 TEST 'Verify modified players list (w/o "Bogus")"'
269 players=$(empires_players_string)
270 test "$players" = "Carl,Richard,Kevin,Stacy,David,Nancy,"
271 TEST_END
272
273 TEST 'Verify modified characters list (w/o "Mr. Bogus")'
274 characters=$(empires_characters_string)
275 test "$characters" = "Bugs Bunny,Bob Hope,Elvis Presley,Phineas,Red Power Ranger,Audrey Hepburn,"
276 TEST_END
277
278 TEST_SUBSECTION "Empires game /capture"
279
280 empires_capture()
281 {
282     curl_post $empires_game_path/capture/$1/$2
283 }
284
285 empires_empires_string()
286 {
287     # Get empires as a compact string (much more compact than JSON)
288     curl_get $empires_game_path/empires | jq -c '.[] | [.id,.captures]' | tr '\n' ','
289 }
290
291 TEST "Verify empires before any captures"
292 empires=$(empires_empires_string)
293 test "$empires" = "[1,[]],[2,[]],[3,[]],[4,[]],[5,[]],[6,[]],"
294 TEST_END
295
296 TEST "Perform some captures"
297 empires_capture 1 2
298 empires_capture 3 5
299 empires_capture 4 6
300 empires_capture 3 4
301 TEST_END
302
303 TEST "Verify empires after captures"
304 empires=$(empires_empires_string)
305 test "$empires" = "[1,[2]],[2,[]],[3,[5,4]],[4,[6]],[5,[]],[6,[]],"
306 TEST_END
307
308 TEST_SUBSECTION "Empires game /liberate"
309
310 empires_liberate()
311 {
312     curl_post $empires_game_path/liberate/$1
313 }
314
315 TEST "Liberate a player"
316 empires_liberate 2
317 TEST_END
318
319 TEST "Verify empires after liberate"
320 empires=$(empires_empires_string)
321 test "$empires" = "[1,[]],[2,[]],[3,[5,4]],[4,[6]],[5,[]],[6,[]],"
322 TEST_END
323
324 TEST_SUBSECTION "Empires game /reset"
325
326 empires_reset()
327 {
328     curl_post $empires_game_path/reset
329 }
330
331 TEST "Reset the game"
332 empires_reset
333 TEST_END
334
335 TEST "Verify players is now empty"
336 players=$(empires_players_string)
337 test "$players" = ""
338 TEST_END
339
340 TEST_SECTION "Tic Tac Toe game"
341
342 tictactoe_game_path=tictactoe/$tictactoe_game_id
343
344 tictactoe_profile()
345 {
346     curl_put /profile "{ \"nickname\": \"$1\" }" "-c .cookie-tictactoe"
347 }
348
349 tictactoe_move()
350 {
351     curl_post $tictactoe_game_path/move "{ \"move\": $1 }" "-b .cookie-tictactoe"
352 }
353
354 tictactoe_player_info()
355 {
356     curl_get $tictactoe_game_path/events  "-m 0.1 -b .cookie-tictactoe" 2>&1 \
357         | grep player-info -A 1 \
358         | grep ^data
359 }
360
361 tictactoe_player_name()
362 {
363     curl_put $tictactoe_game_path/player "{ \"name\": \"$1\" }" "-b .cookie-tictactoe"
364 }
365
366 tictactoe_player_team()
367 {
368     curl_put $tictactoe_game_path/player "{ \"team\": \"$1\" }" "-b .cookie-tictactoe"
369 }
370
371 TEST_SUBSECTION "Tic Tac Toe player-info"
372
373 TEST "Hit LMNO /profile to set name to 'curl'"
374 tictactoe_profile curl
375 TEST_END
376
377 TEST "Verify player-info event reports 'curl' name"
378 result=$(tictactoe_player_info)
379 test "$result" = 'data: {"id":1,"active":true,"name":"curl","team":""}'
380 TEST_END
381
382 TEST_SUBSECTION "Tic Tac Toe /player"
383
384 TEST "Change name to 'newname'"
385 tictactoe_player_name newname
386 result=$(tictactoe_player_info)
387 test "$result" = 'data: {"id":1,"active":true,"name":"newname","team":""}'
388 TEST_END
389
390 TEST "Change team to 'X'"
391 tictactoe_player_team X
392 result=$(tictactoe_player_info)
393 test "$result" = 'data: {"id":1,"active":true,"name":"newname","team":"X"}'
394 TEST_END
395
396 TEST "Change team to 'O'"
397 tictactoe_player_team O
398 result=$(tictactoe_player_info)
399 test "$result" = 'data: {"id":1,"active":true,"name":"newname","team":"O"}'
400 TEST_END
401
402 TEST "Verify cannot change team to 'Z'"
403 tictactoe_player_team Z
404 result=$(tictactoe_player_info)
405 test "$result" = 'data: {"id":1,"active":true,"name":"newname","team":"O"}'
406 TEST_END
407
408 TEST "Leave current team"
409 tictactoe_player_team ""
410 result=$(tictactoe_player_info)
411 test "$result" = 'data: {"id":1,"active":true,"name":"newname","team":""}'
412 TEST_END
413
414 TEST_SUBSECTION "Tic Tac Toe /move"
415
416 TEST "First move doesn't require a team"
417 result=$(tictactoe_move 0)
418 test "$result" = '{"legal":true}'
419 TEST_END
420
421 TEST "Second move does require a team"
422 result=$(tictactoe_move 4)
423 test "$result" = '{"legal":false,"message":"It'"'"'s not your turn to move"}'
424 TEST_END
425
426 TEST "Illegal to move when it's not your turn"
427 tictactoe_player_team X
428 result=$(tictactoe_move 4)
429 test "$result" = '{"legal":false,"message":"It'"'"'s not your turn to move"}'
430 TEST_END
431
432 TEST "Legal move to center square"
433 tictactoe_player_team O
434 result=$(tictactoe_move 4)
435 test "$result" = '{"legal":true}'
436 TEST_END
437
438 TEST "Move to center square again is now illegal"
439 tictactoe_player_team X
440 result=$(tictactoe_move 4)
441 test "$result" = '{"legal":false,"message":"Square is already occupied"}'
442 TEST_END
443
444 TEST_SECTION "Scribe game"
445
446 TEST "Create Scribe game"
447 scribe_game_id=$(new_game scribe)
448 test "$scribe_game_id" != ""
449 TEST_END $scribe_game_id
450
451 scribe_game_path=scribe/$scribe_game_id
452
453 # Usage: scribe_profile <name>
454 scribe_profile()
455 {
456     curl_put /profile "{ \"nickname\": \"$1\" }" "-c .cookie-scribe"
457 }
458
459 # Pulls a single named event out of the scribe event stream
460 #
461 # Usage: scribe_get_event <event_name>
462 scribe_get_event()
463 {
464     curl_get $scribe_game_path/events "-m 0.1 -b .cookie-scribe" 2>&1 \
465         | grep "^event: $1" -A 1 \
466         | grep ^data: \
467         | sed -e 's,^data: *,,'
468 }
469
470 # Usage: scribe_player_name
471 scribe_get_player_name()
472 {
473     scribe_get_event player-info | jq -r .name
474 }
475
476 TEST_SUBSECTION "Scribe player-info"
477
478 TEST "Hit LMNO /profile to set name to 'test-suite'"
479 scribe_profile test-suite
480 TEST_END
481
482 TEST "Verify player-info event reports 'test-suite' name"
483 result=$(scribe_get_player_name)
484 test "$result" = "test-suite"
485 TEST_END
486
487 scribe_player_info()
488 {
489     scribe_get_event player-info
490 }
491
492 scribe_set_player_name()
493 {
494     curl_put $scribe_game_path/player "{ \"name\": \"$1\" }" "-b .cookie-scribe"
495 }
496
497 scribe_set_player_team()
498 {
499     curl_put $scribe_game_path/player "{ \"team\": \"$1\" }" "-b .cookie-scribe"
500 }
501
502 TEST_SUBSECTION "Scribe /player"
503
504 TEST "Change name to 'testy'"
505 scribe_set_player_name testy
506 result=$(scribe_player_info)
507 test "$result" = '{"id":1,"active":true,"name":"testy","team":""}'
508 TEST_END
509
510 TEST "Change team to '+'"
511 scribe_set_player_team +
512 result=$(scribe_player_info)
513 test "$result" = '{"id":1,"active":true,"name":"testy","team":"+"}'
514 TEST_END
515
516 TEST "Change team to 'o'"
517 scribe_set_player_team o
518 result=$(scribe_player_info)
519 test "$result" = '{"id":1,"active":true,"name":"testy","team":"o"}'
520 TEST_END
521
522 TEST "Verify cannot change team to 'X'"
523 scribe_set_player_team X
524 result=$(scribe_player_info)
525 test "$result" = '{"id":1,"active":true,"name":"testy","team":"o"}'
526 TEST_END
527
528 TEST "Leave current team"
529 scribe_set_player_team ""
530 result=$(scribe_player_info)
531 test "$result" = '{"id":1,"active":true,"name":"testy","team":""}'
532 TEST_END
533
534 scribe_move()
535 {
536     curl_post $scribe_game_path/move "{ \"move\": $1 }" "-b .cookie-scribe"
537 }
538
539 TEST_SUBSECTION "Scribe /move"
540
541 TEST "First move doesn't require a team"
542 result=$(scribe_move '[4,0]')
543 test "$result" = '{"legal":true}'
544 TEST_END
545
546 TEST "Second move does require a team"
547 result=$(scribe_move '[0,3]')
548 test "$result" = '{"legal":false,"message":"It'"'"'s not your turn to move"}'
549 TEST_END
550
551 TEST "Illegal to move when it's not your turn"
552 scribe_set_player_team +
553 result=$(scribe_move '[0,3]')
554 test "$result" = '{"legal":false,"message":"It'"'"'s not your turn to move"}'
555 TEST_END
556
557 TEST "Legal move to an empty square"
558 scribe_set_player_team o
559 result=$(scribe_move '[0,3]')
560 test "$result" = '{"legal":true}'
561 TEST_END
562
563 TEST "Move to same again is now illegal"
564 scribe_set_player_team +
565 result=$(scribe_move '[0,3]')
566 test "$result" = '{"legal":false,"message":"Square is already occupied"}'
567 TEST_END
568
569 TEST "Move must be in correct mini-grid by last move"
570 scribe_set_player_team +
571 result=$(scribe_move '[1,8]')
572 test "$result" = '{"legal":false,"message":"Move is inconsistent with your previous move"}'
573 TEST_END
574
575 TEST "Move in correct mini-grid is now legal"
576 result=$(scribe_move '[0,8]')
577 test "$result" = '{"legal":true}'
578 TEST_END
579
580
581 TEST_SECTION "Empathy game"
582
583 TEST_SUBSECTION "Create a game and register 3 players"
584
585 TEST "Create the game"
586 empathy_game_id=$(new_game empathy)
587 test "$empathy_game_id" != ""
588 TEST_END $empathy_game_id
589
590 empathy_game_path=empathy/$empathy_game_id
591
592 # Usage: empathy_get <player_name> <endpoint> [curl_options]
593 empathy_get()
594 {
595     curl_get_cookie $1 $empathy_game_path/$2 "${3:-}"
596 }
597
598 # Usage: empathy_post <player_name> <endpoint> [data]
599 empathy_post()
600 {
601     curl_post_cookie $1 $empathy_game_path/$2 "${3:-}"
602 }
603
604 # Given a player name as $1 (eg. "empathy_player_activate alice") set both
605 # $1_cookie and $1_pid (that is $alice_cookie and $alice_pid) to
606 # a filename containing a cookie and the PID of a running event-streaming
607 # process.
608 empathy_player_activate()
609 {
610     player="$1"
611     player_cookie=${player}_cookie
612     player_pid=${player}_pid
613
614     eval ${player_cookie}=".cookie-empathy-$player"
615     curl_put /profile "{ \"nickname\": \"$player\" }" "-c ${!player_cookie}"
616     empathy_get $player events >/dev/null 2>&1 &
617     eval ${player_pid}=$!
618     empathy_players+=($player)
619 }
620
621 empathy_player_reactivate()
622 {
623     player="$1"
624     player_pid=${player}_pid
625
626     empathy_get $player events >/dev/null 2>&1 &
627     eval ${player_pid}=$!
628 }
629
630 # Usage: empathy_player_deactivate <player_name>
631 empathy_player_deactivate()
632 {
633     player="$1"
634     player_pid=${player}_pid
635     if [ "${!player_pid}" != "" ]; then
636         pkill -P ${!player_pid}
637     fi
638     eval ${player_pid}=""
639 }
640
641 empathy_deactivate_all()
642 {
643     for player in ${empathy_players[*]}; do
644         empathy_player_deactivate $player
645     done
646 }
647
648 # Pulls a single named event out of the empathy event stream
649 #
650 # Usage: empathy_get_event <player_name> <event_name>
651 empathy_get_event()
652 {
653     empathy_get $1 events "-m 0.1" 2>&1 \
654         | grep "^event: $2" -A 1 \
655         | grep ^data: \
656         | sed -e 's,^data: *,,'
657 }
658
659 # Usage: empathy_player_name <player_name>
660 empathy_player_name()
661 {
662     empathy_get_event $1 player-info | jq -r .name
663 }
664
665 TEST "Set 'alice' in session"
666 empathy_player_activate alice
667 test "$alice_cookie" = ".cookie-empathy-alice"
668 TEST_END
669
670 TEST "Register alice and verify name"
671 result=$(empathy_player_name alice)
672 test "$result" = "alice"
673 TEST_END
674
675 TEST "Register bob"
676 empathy_player_activate bob
677 result=$(empathy_player_name bob)
678 test "$result" = "bob"
679 TEST_END
680
681 TEST "Register charlie"
682 empathy_player_activate charlie
683 result=$(empathy_player_name charlie)
684 test "$result" = "charlie"
685 TEST_END
686
687 TEST_SUBSECTION "Category selection"
688
689 # Usage: empathy_submit_prompt <player_name> <count> <prompt_string>
690 empathy_submit_prompt()
691 {
692     empathy_post $1 prompts "{ \"items\": $2, \"prompt\": \"$3\"}"
693 }
694
695 TEST "Huge numbers are rejected"
696 result=$(empathy_submit_prompt alice 10000 "10,000 Maniacs")
697 test "$result" = '{"valid":false,"message":"Maximum number of items is 20"}'
698 TEST_END
699
700 TEST "Submit a category"
701 prompt_id=$(empathy_submit_prompt alice 4 "4 things on a beach" | jq .id)
702 test "$prompt_id" = "1"
703 TEST_END
704
705 # Usage: empathy_vote <player_name> <prompt_id>
706 empathy_vote()
707 {
708     empathy_post $1 vote/$2
709 }
710
711 TEST "Vote on this category"
712 empathy_vote alice $prompt_id
713 test "$?" = "0"
714 TEST_END
715
716 # Usage: empathy_start <player_name> <prompt_id>
717 empathy_start()
718 {
719     empathy_post $1 start/$2
720 }
721
722 TEST "Start the game with this category"
723 empathy_start alice $prompt_id
724 test "$?" = "0"
725 TEST_END
726
727 # Usage: empathy_answer <player_name> <prompt_id> <answers_string>
728 empathy_answer()
729 {
730     empathy_post $1 answer/$2 "{ \"answers\": [$3]}"
731 }
732
733 TEST_SUBSECTION "Submitting answers"
734
735 TEST "Submit from a non-player fails"
736 bogus_cookie=/dev/null
737 result=$(empathy_answer bogus $prompt_id '"Sun", "Sand", "Water", "People"')
738 test "$result" = '{"valid":false,"message":"Player not found"}'
739 TEST_END
740
741 TEST "Submit from alice succeeds"
742 result=$(empathy_answer alice $prompt_id '"sun", "sand", "water", "people"')
743 test "$result" = '{"valid":true}'
744 TEST_END
745
746 TEST "Submit from bob succeeds"
747 result=$(empathy_answer bob $prompt_id '"sand", "sands", "SunLight", "towels"')
748 test "$result" = '{"valid":true}'
749 TEST_END
750
751 # Usage: empathy_ambiguities <player_name>
752 empathy_ambiguities()
753 {
754     empathy_get_event $1 game-state | jq .ambiguities
755 }
756
757 TEST "Judging hasn't started with player unsubmitted"
758 result=$(echo $(empathy_ambiguities alice))
759 test "$result" = "null"
760 TEST_END
761
762 TEST "Submit from charlie succeeds"
763 result=$(empathy_answer charlie $prompt_id '"SunShine", "Grains of Sand", "wafer", "people"')
764 test "$result" = '{"valid":true}'
765 TEST_END
766
767 TEST_SUBSECTION "Transition from answering to judging (no voting needed)"
768
769 TEST "Judging already started"
770 result=$(echo $(empathy_ambiguities alice))
771 test "$result" != "null"
772 TEST_END
773
774 TEST_SUBSECTION "Judging answers"
775
776 # Usage: empathy_ambiguities_list <player_name>
777 empathy_ambiguities_list()
778 {
779     empathy_get_event $1 game-state | jq .ambiguities[]
780 }
781
782 TEST "Received all unique words"
783 # echo here is to strip newlines
784 result=$(echo $(empathy_ambiguities_list alice))
785 test "$result" = '"Grains of Sand" "people" "sand" "sands" "sun" "SunLight" "SunShine" "towels" "wafer" "water"'
786 TEST_END
787
788 # Usage: empathy_judged <player_name> <prompt_id> <word_groups_string>
789 empathy_judged()
790 {
791     empathy_post $1 judged/$2 "{ \"word_groups\": $3}"
792 }
793
794 TEST "Submit word groups from alice"
795 result=$(empathy_judged alice $prompt_id '[{"words":["sun","SunLight","SunShine"],"kudos":false},{"words":["sand","sands","Grains of Sand"],"kudos":false},{"words":["water","wafer"],"kudos":false}]')
796 test "$result" = '{"valid":true}'
797 TEST_END
798
799 TEST "Submit word groups from bob"
800 result=$(empathy_judged bob $prompt_id '[{"words":["sands","grains of sand"],"kudos":false},{"words":["water","wafer"],"kudos":false}]')
801 test "$result" = '{"valid":true}'
802 TEST_END
803
804 # Usage: empathy_scores <player_name>
805 empathy_scores()
806 {
807     empathy_get_event $1 game-state | jq .scores
808 }
809
810 TEST "Scoring hasn't started with player unsubmitted"
811 result=$(echo $(empathy_scores alice))
812 test "$result" = "null"
813 TEST_END
814
815 TEST "Submit word groups from charlie"
816 result=$(empathy_judged charlie $prompt_id '[{"words":["SunLight","SunShine"],"kudos":false},{"words":["sand","Grains of Sand"],"kudos":false}]')
817 test "$result" = '{"valid":true}'
818 TEST_END
819
820 TEST_SUBSECTION "Transition from judging to scoring (no voting needed)"
821
822 TEST "Scoring already started"
823 result=$(echo $(empathy_scores alice))
824 test "$result" != "null"
825 TEST_END
826
827 # Usage: empathy_scores_names_numbers <player_name>
828 empathy_scores_names_numbers()
829 {
830     empathy_get_event $1 game-state | jq '.scores.scores[]|.players[],.score'
831 }
832
833 TEST_SUBSECTION "Scoring"
834
835 TEST "Verify final scores as expected"
836 # echo here is to strip newlines
837 result=$(echo $(empathy_scores_names_numbers alice))
838 test "$result" = '"charlie" 9 "alice" 8 "bob" 6'
839 TEST_END
840
841 # Usage: empathy_words_submitted <player_name>
842 empathy_words_submitted()
843 {
844     empathy_get_event $1 game-state | jq '.scores.words[].word'
845 }
846
847 TEST "Verify final list of words submitted"
848 # echo here is to strip newlines
849 result=$(echo $(empathy_words_submitted alice))
850 test "$result" = '"Grains of Sand/sand/sands" "SunLight/SunShine" "wafer/water" "people" "sun" "towels"'
851 TEST_END
852
853 TEST_SUBSECTION "New game (using voting to advance phases)"
854
855 empathy_reset()
856 {
857     curl_post $empathy_game_path/reset
858 }
859
860 TEST "Any post to /reset resets the game"
861 empathy_reset
862 test "$?" = "0"
863 TEST_END
864
865 TEST "Verify scoring is over"
866 result=$(echo $(empathy_scores alice))
867 test "$result" = "null"
868 TEST_END
869
870 # Usage: empathy_answering <player_name> <prompt_id>
871 empathy_answering()
872 {
873     empathy_post $1 answering/$2
874 }
875
876 TEST "Start 4-player game, 3 submissions"
877 empathy_player_activate dale
878 result=$(empathy_player_name dale)
879 test "$result" = "dale"
880 prompt_id=$(empathy_submit_prompt alice 4 "3 little words" | jq .id)
881 empathy_start alice $prompt_id
882 empathy_answer alice   $prompt_id '"I",    "love", "you"' >/dev/null
883 empathy_answer bob     $prompt_id '"I",    "love", "food"' >/dev/null
884 empathy_answer charlie $prompt_id '"food", "is",   "good"' >/dev/null
885 result=$(empathy_answering dale $prompt_id)
886 test "$result" = '{"valid":true}'
887 TEST_END
888
889 TEST "Judging hasn't started with player unsubmitted"
890 result=$(echo $(empathy_ambiguities alice))
891 test "$result" = "null"
892 TEST_END
893
894 # Usage: empathy_end_answers <player_name> <prompt_id>
895 empathy_end_answers()
896 {
897     empathy_post $1 end-answers/$2
898 }
899
900 TEST "Minority of players vote to end answering"
901 empathy_end_answers alice $prompt_id
902 empathy_end_answers bob $prompt_id
903 test "$?" = "0"
904 TEST_END
905
906 TEST "Judging still hasn't started"
907 result=$(echo $(empathy_ambiguities alice))
908 test "$result" = "null"
909 TEST_END
910
911 TEST "Majority of players vote to end answering"
912 empathy_end_answers charlie $prompt_id
913 test "$?" = "0"
914 TEST_END
915
916 TEST "Judging has now started"
917 result=$(echo $(empathy_ambiguities alice))
918 test "$result" != "null"
919 TEST_END
920
921 # Usage: empathy_players_judging <player_name>
922 empathy_players_judging()
923 {
924     empathy_get_event $1 game-state | jq .players_judging[]
925 }
926
927 TEST "Verify active players listed as judging"
928 # echo here is to strip newlines
929 result=$(echo $(empathy_players_judging alice))
930 test "$result" = '"alice" "bob" "charlie"'
931 TEST_END
932
933 TEST "Submit word groups from majority"
934 empathy_judged alice $prompt_id '[]' >/dev/null
935 result=$(empathy_judged bob $prompt_id '[]')
936 test "$result" = '{"valid":true}'
937 TEST_END
938
939 TEST "Scoring hasn't started with player unsubmitted"
940 result=$(echo $(empathy_scores alice))
941 test "$result" = "null"
942 TEST_END
943
944 # Usage: empathy_end_judging <player_name> <prompt_id>
945 empathy_end_judging()
946 {
947     empathy_post $1 end-judging/$2
948 }
949
950 TEST "Minority of players vote to end judging"
951 empathy_end_judging alice $prompt_id
952 test "$?" = "0"
953 TEST_END
954
955 TEST "Scoring still hasn't started"
956 result=$(echo $(empathy_scores alice))
957 test "$result" = "null"
958 TEST_END
959
960 TEST "Majority of players vote to end judging"
961 empathy_end_judging bob $prompt_id
962 test "$?" = "0"
963 TEST_END
964
965 TEST "Scoring has now started"
966 result=$(echo $(empathy_scores alice))
967 test "$result" != "null"
968 TEST_END
969
970 TEST_SUBSECTION "New game (no voting needed when all answered players judge)"
971
972 TEST "Start 4-player game, 3 submissions"
973 empathy_reset
974 prompt_id=$(empathy_submit_prompt alice 4 "1 truth or dare" | jq .id)
975 empathy_start alice $prompt_id
976 empathy_answer alice   $prompt_id '"truth"' >/dev/null
977 empathy_answer bob     $prompt_id '"truth"' >/dev/null
978 empathy_answer charlie $prompt_id '"dare"' >/dev/null
979 empathy_end_answers alice $prompt_id
980 empathy_end_answers bob $prompt_id
981 empathy_end_answers charlie $prompt_id
982 test "$?" = "0"
983 TEST_END
984
985 TEST "Submit word groups from 2 players"
986 empathy_judged alice $prompt_id '[]' >/dev/null
987 result=$(empathy_judged bob $prompt_id '[]')
988 test "$result" = '{"valid":true}'
989 TEST_END
990
991 TEST "Scoring hasn't started with player unsubmitted"
992 result=$(echo $(empathy_scores alice))
993 test "$result" = "null"
994 TEST_END
995
996 TEST "Submit word groups from a non-answering player"
997 result=$(empathy_judged dale $prompt_id '[]')
998 test "$result" = '{"valid":true}'
999 TEST_END
1000
1001 TEST "Scoring still hasn't started"
1002 result=$(echo $(empathy_scores alice))
1003 test "$result" = "null"
1004 TEST_END
1005
1006 TEST "Submit word groups from last answering player"
1007 result=$(empathy_judged charlie $prompt_id '[]')
1008 test "$result" = '{"valid":true}'
1009 TEST_END
1010
1011 TEST "Scoring has now started"
1012 result=$(echo $(empathy_scores alice))
1013 test "$result" != "null"
1014 TEST_END
1015
1016 TEST_SUBSECTION "Non players don't affect judging requirements"
1017
1018 TEST "Start 2-player game with 6 registered players"
1019 empathy_reset
1020 empathy_player_activate eric
1021 empathy_player_activate fred
1022 prompt_id=$(empathy_submit_prompt alice 4 "1 truth or dare" | jq .id)
1023 empathy_start alice $prompt_id
1024 empathy_answer alice $prompt_id '"truth"' >/dev/null
1025 empathy_answer bob   $prompt_id '"true"' >/dev/null
1026 empathy_end_answers alice $prompt_id
1027 empathy_end_answers bob $prompt_id
1028 test "$?" = "0"
1029 TEST_END
1030
1031 TEST "1 player votes for a match"
1032 empathy_judged alice $prompt_id '[{"words":["truth","true"],"kudos":false}]' >/dev/null
1033 result=$(empathy_judged bob $prompt_id '[]')
1034 test "$result" = '{"valid":true}'
1035 TEST_END
1036
1037 TEST "Verify the match passed the vote"
1038 # echo here is to strip newlines
1039 result=$(echo $(empathy_scores_names_numbers alice))
1040 test "$result" = '"alice" "bob" 2 "charlie" "dale" "eric" "fred" 0'
1041 TEST_END
1042
1043 echo ""
1044 echo "NOTE: Slow tests ahead!"
1045 echo "If you are impatient and somehow \"know\" you don't care about the"
1046 echo "tests below then you can interrupt the test suite with Control-C"
1047 echo "to get a summary report on the tests that have already been run."
1048
1049 TEST_SUBSECTION "Inactive players don't appear in scores"
1050
1051 TEST "Start 2-player game with 6 registered players"
1052 empathy_reset
1053 prompt_id=$(empathy_submit_prompt alice 4 "1 best pet" | jq .id)
1054 empathy_start alice $prompt_id
1055 empathy_answer alice $prompt_id '"cats"' >/dev/null
1056 empathy_answer bob   $prompt_id '"dogs"' >/dev/null
1057 empathy_end_answers alice $prompt_id
1058 empathy_end_answers bob $prompt_id
1059 test "$?" = "0"
1060 TEST_END
1061
1062 TEST "Deactivate 3 players"
1063 empathy_player_deactivate dale
1064 empathy_player_deactivate eric
1065 empathy_player_deactivate fred
1066 sleep 30
1067 test "$?" = "0"
1068 TEST_END
1069
1070 TEST "Finish game with 2 active players"
1071 empathy_judged alice $prompt_id '[]' >/dev/null
1072 result=$(empathy_judged bob $prompt_id '[]')
1073 test "$result" = '{"valid":true}'
1074 TEST_END
1075
1076 TEST "Verify scores don't include inactive players"
1077 # echo here is to strip newlines
1078 result=$(echo $(empathy_scores_names_numbers alice))
1079 test "$result" = '"alice" "bob" 1 "charlie" 0'
1080 TEST_END
1081
1082 TEST_SUBSECTION "Deactivated players don't block future game phase advances"
1083
1084 TEST "New 3-player game, 2 submit right away"
1085 empathy_reset
1086 prompt_id=$(empathy_submit_prompt charlie 4 "2 legit 2 quit" | jq .id)
1087 empathy_start alice $prompt_id
1088 empathy_answer alice $prompt_id '"what", "gives?"' >/dev/null
1089 empathy_answer bob   $prompt_id '"so", "confused"' >/dev/null
1090 test "$?" = "0"
1091 TEST_END
1092
1093 TEST "Judging hasn't started with player unsubmitted"
1094 result=$(echo $(empathy_ambiguities alice))
1095 test "$result" = "null"
1096 TEST_END
1097
1098 TEST "Final active player submits"
1099 result=$(empathy_answer charlie $prompt_id '"best", "category"')
1100 test "$result" = '{"valid":true}'
1101 TEST_END
1102
1103 TEST "Judging has started (don't need inactive players)"
1104 result=$(echo $(empathy_ambiguities alice))
1105 test "$result" != "null"
1106 TEST_END
1107
1108 TEST "Submit word groups from 2 players"
1109 empathy_judged alice $prompt_id '[]' >/dev/null
1110 result=$(empathy_judged bob $prompt_id '[]')
1111 test "$result" = '{"valid":true}'
1112 TEST_END
1113
1114 TEST "Scoring hasn't started with player unsubmitted"
1115 result=$(echo $(empathy_scores alice))
1116 test "$result" = "null"
1117 TEST_END
1118
1119 TEST "Submit word groups from last answering player"
1120 result=$(empathy_judged charlie $prompt_id '[]')
1121 test "$result" = '{"valid":true}'
1122 TEST_END
1123
1124 TEST "Scoring has now started"
1125 result=$(echo $(empathy_scores alice))
1126 test "$result" != "null"
1127 TEST_END
1128
1129 TEST_SUBSECTION "Reactivated player is fully active"
1130
1131 TEST "The dale player is currently deactivated"
1132 test "$dale_pid" = ""
1133 TEST_END
1134
1135 TEST "Reactivate dale"
1136 empathy_player_reactivate dale
1137 test "$dale_pid" != ""
1138 TEST_END
1139
1140 TEST "New 4-player game, 3 submit right away"
1141 empathy_reset
1142 prompt_id=$(empathy_submit_prompt alice 1 "favorite letter" | jq .id)
1143 empathy_start alice $prompt_id
1144 empathy_answer alice   $prompt_id '"A"' >/dev/null
1145 empathy_answer bob     $prompt_id '"B"' >/dev/null
1146 empathy_answer charlie $prompt_id '"C"' >/dev/null
1147 test "$?" = "0"
1148 TEST_END
1149
1150 TEST "Judging hasn't started with player unsubmitted"
1151 result=$(echo $(empathy_ambiguities alice))
1152 test "$result" = "null"
1153 TEST_END
1154
1155 TEST "Final active player submits"
1156 result=$(empathy_answer dale $prompt_id '"D"')
1157 test "$result" = '{"valid":true}'
1158 TEST_END
1159
1160 TEST "Judging has started now"
1161 result=$(echo $(empathy_ambiguities alice))
1162 test "$result" != "null"
1163 TEST_END
1164
1165 cleanup_and_report